// CoffeeKup Template Engine wrapper for SocketStream 0.3

var _ = require('underscore');

exports.init = function(root, config) {

  // Set global/window variable used to access templates from the browser
  var namespace = config && config.namespace || 'UT'

  return {

    name: 'Underscore',

    // Opening code to use when a CoffeeKup template is called for the first time
    prefix: function() {
      return '<script type="text/javascript">if(!window.' + namespace + '){window.' + namespace + ' = {};}';
    },

    // Closing code once all CoffeeKup templates have been written into the <script> tag
    suffix: function() {
      return '</script>';
    },

    // Compile template into a function and attach to window.<namespace>
    process: function(template, path, id) {

      var compiledTemplate = _.template(template).toString();

      return 'window.' + namespace + '[\''+id+'\'] = ' + compiledTemplate + ';';
    }
  }
}